#include <stddef.h>
#include <stdlib.h>
#include "assert.h"
#include "intlist.h"

#define T Intlist_T


T
Intlist_push (T intlist, int x) {
  T p = (T) malloc(sizeof(*p));
  
  p->first = x;
  p->rest = intlist;
  return p;
}

void
Intlist_free (T *intlist) {
  T next;

  for ( ; *intlist; *intlist = next) {
    next = (*intlist)->rest;
    free(*intlist);
  }
}

int
Intlist_find (T intlist, int x) {
  for ( ; intlist; intlist = intlist->rest) {
    if (intlist->first == x) {
      return 1;
    }
  }
  return 0;
}

